static const char _rcsid_[] = "$Id: xio-readline.c,v 1.2 2002/04/16 10:58:34 gerhard Exp $";
/* Copyright Gerhard Rieger 2002 */
/* Published under the GNU General Public License V.2, see file COPYING */

/* this file contains the source for opening the readline address */

#include "xiosysincludes.h"
#include "xioopen.h"

#include "xio-termios.h"
#include "xio-readline.h"


#if WITH_READLINE

/*
options: history file
	prompt
	mode=vi?
	inputrc=?

uses stdin!!
*/

static int xioopen_readline(char *arg, int rw, xiofile_t *xfd, unsigned groups,
			    int dummy1, int dummy2, void *dummyp1);


const struct addrdesc addr_readline = {
   "readline", 3, xioopen_readline, GROUP_FD|GROUP_TERMIOS|GROUP_READLINE, 0, 0, NULL HELP(NULL) };

const struct optdesc opt_history_file = { "history-file", "history", OPT_HISTORY_FILE, GROUP_READLINE, PH_LATE, TYPE_STRING,  OFUNC_OFFSET, (int)&((xiofile_t *)0)->stream.para.readline.history_file };


static int xioopen_readline(char *arg, int rw, xiofile_t *xfd, unsigned groups,
			    int dummy1, int dummy2, void *dummyp1) {
   char msgbuf[256], *cp = msgbuf;
   struct opt *opts = NULL;

   strcpy(cp, "using "); cp = strchr(cp, '\0');
   if ((rw+1)&1) {
      strcpy(cp, "readline on stdin for reading"); cp = strchr(cp, '\0');

      if ((rw+1)&2)
      strcpy(cp, " and ");  cp = strchr(cp, '\0');
   }
   if ((rw+1)&2) {
      strcpy(cp, "stdio for writing"); cp = strchr(cp, '\0');
   }
   Notice(msgbuf);

#if 0
   if (*arg != '\0' && *arg != ',') {
      Error("readline takes no parameters");
      return -1;
   }
#endif

   xfd->stream.fd = 0;	/* stdin */
   xfd->stream.howtoend = END_NONE;
   xfd->stream.dtype    = DATA_READLINE;

   if (parseopts(arg, groups|groupbits(xfd->stream.fd), &opts) < 0)
      return STAT_NORETRY;
   applyopts(-1, opts, PH_INIT);

   applyopts2(xfd->stream.fd, opts, PH_INIT, PH_FD);

   Using_history();
   applyopts_offset(xfd, opts);
   if (xfd->stream.para.readline.history_file) {
      Read_history(xfd->stream.para.readline.history_file);
   }
   xiotermios_clrflag(xfd->stream.fd, 3, ICANON);
   xiotermios_clrflag(xfd->stream.fd, 3, ECHO);
   return _xio_openlate(&xfd->stream, opts);
}

#endif /* WITH_READLINE */
